summaryrefslogtreecommitdiff
path: root/bin
diff options
context:
space:
mode:
authorJonas Smedegaard <dr@jones.dk>2017-04-24 10:12:09 +0200
committerJonas Smedegaard <dr@jones.dk>2017-04-24 10:12:09 +0200
commit9de9eb344f1c274fac00c6eaa97351f4a2958082 (patch)
treeb53013eafd5a273a32e31e8a428bc59464ef02b7 /bin
parent5f51d9a1ac60fcb524344bf0987957fcf0c212f2 (diff)
Add capture+encode+stream (fork of loop+encode+stream).
Diffstat (limited to 'bin')
-rwxr-xr-xbin/capture+encode+stream39
1 files changed, 39 insertions, 0 deletions
diff --git a/bin/capture+encode+stream b/bin/capture+encode+stream
new file mode 100755
index 0000000..223b69b
--- /dev/null
+++ b/bin/capture+encode+stream
@@ -0,0 +1,39 @@
+#!/bin/sh
+
+set -e
+
+AINPUT=hw:0
+VINPUT=/dev/fw1
+
+HOST=${1:-morla}
+if [ "$HOST" = "$(hostname --short)" ]; then
+ IP=127.0.0.1
+else
+ IP=$(host "$HOST" | grep -Po 'address \K\S+')
+fi
+
+FIRSTPORT=${2:-5002} # even number - next 3 ports used too
+
+ACHANNELS=2
+AFRAMERATE=48000
+ABITRATE=32000
+
+VBITRATE=256000
+
+# based on http://www.webmproject.org/docs/encoder-parameters/#real-time-cbr-encoding-and-streaming
+# + Add 1s latency (deadline)
+# + Use same RTP payload types as GStreamer
+ffmpeg -threads auto -re \
+ -f alsa -sample_rate "$AFRAMERATE" -channels "$ACHANNELS" -thread_queue_size 1024 -i "$AINPUT" \
+ -f libdc1394 -video_size 640x480 -framerate 15 -thread_queue_size 256 -i "$VINPUT" \
+ -codec:a libopus -ac "$ACHANNELS" -ar "$AFRAMERATE" -b:a "$ABITRATE" \
+ -vn \
+ -f rtp -payload_type 111 "rtp://$IP:$FIRSTPORT?pkt_size=1200" \
+ -an \
+ -pix_fmt yuv420p \
+ -codec:v vp8 -quality realtime -deadline 1000000 -cpu-used 15 \
+ -b:v "$VBITRATE" -minrate "$VBITRATE" -maxrate "$VBITRATE" \
+ -undershoot-pct 95 -bufsize $((6000*VBITRATE/1000)) -rc_init_occupancy $((4000*VBITRATE/1000)) \
+ -max-intra-rate 0 \
+ -qmin 4 -qmax 56 \
+ -f rtp -payload_type 100 "rtp://$IP:$((FIRSTPORT+2))?pkt_size=1200"